##############################################################################################################
######### Testing Modularity of Avian Dawn Choruses in Highly Urbanized and Periurban Areas ##################
##############################################################################################################

# Open the xls file: dawn_chorus_networks, and export and save each sheet in cvs format in order to calculate modularity and nestedness metrics

########################### Calculate Modularity in periurban Areas ###################################
###### periurban1
library(bipartite)
rm(list= ls())
datos<- read.csv("periurban1.csv", row.names=1)
mod <- computeModules(web=datos, steps=1E2, deep=F)
mod@likelihood
plotModuleWeb(mod)
nulls <- nullmodel(datos, N=100, method="r2d")
modules.nulls <- sapply(nulls, computeModules)
like.nulls <- sapply(modules.nulls, function(x) x@likelihood)
plot(density(like.nulls), xlim=c(min((mod@likelihood), min(like.nulls)), max((mod@likelihood), max(like.nulls))), 
     main="comparison of observed with null model Patefield")
abline(v=(mod@likelihood), col="red", lwd=2)    
mean(like.nulls)
sd(like.nulls)
mod@likelihood
praw <- sum(like.nulls>(mod@likelihood)) / length(like.nulls)
ifelse(praw > 0.5, 1-praw, praw)                                  e
(z <- (mod@likelihood - mean(like.nulls))/sd(like.nulls))         

###### periurban2
library(bipartite)
rm(list= ls())
datos<- read.csv("periurban2.csv", row.names=1)
mod <- computeModules(web=datos, steps=1E7, deep=F)
mod@likelihood
plotModuleWeb(mod)
nulls <- nullmodel(datos, N=100, method="r2d") #Pode trocar por quantas permutacoes quiser
modules.nulls <- sapply(nulls, computeModules)
like.nulls <- sapply(modules.nulls, function(x) x@likelihood)
plot(density(like.nulls), xlim=c(min((mod@likelihood), min(like.nulls)), max((mod@likelihood), max(like.nulls))), 
     main="comparison of observed with null model Patefield")
abline(v=(mod@likelihood), col="red", lwd=2)    
mean(like.nulls)
sd(like.nulls)
mod@likelihood
praw <- sum(like.nulls>(mod@likelihood)) / length(like.nulls)
ifelse(praw > 0.5, 1-praw, praw)                                
(z <- (mod@likelihood - mean(like.nulls))/sd(like.nulls))        

###### periurban3
library(bipartite)
rm(list= ls())
datos<- read.csv("periurban3.csv", row.names=1)
mod <- computeModules(web=datos, steps=1E3, deep=F)
mod@likelihood
plotModuleWeb(mod)
nulls <- nullmodel(datos, N=100, method="r2d") 
modules.nulls <- sapply(nulls, computeModules)
like.nulls <- sapply(modules.nulls, function(x) x@likelihood)
plot(density(like.nulls), xlim=c(min((mod@likelihood), min(like.nulls)), max((mod@likelihood), max(like.nulls))), 
     main="comparison of observed with null model Patefield")
abline(v=(mod@likelihood), col="red", lwd=2)    
mean(like.nulls)
sd(like.nulls)
mod@likelihood
praw <- sum(like.nulls>(mod@likelihood)) / length(like.nulls)
ifelse(praw > 0.5, 1-praw, praw)                                 
(z <- (mod@likelihood - mean(like.nulls))/sd(like.nulls))         


###### periurban4
library(bipartite)
rm(list= ls())
datos<- read.csv("periurban4.csv", row.names=1)
mod <- computeModules(web=datos, steps=1E3, deep=F)
plotModuleWeb(mod)
nulls <- nullmodel(datos, N=100, method="r2d")
modules.nulls <- sapply(nulls, computeModules)
like.nulls <- sapply(modules.nulls, function(x) x@likelihood)
plot(density(like.nulls), xlim=c(min((mod@likelihood), min(like.nulls)), max((mod@likelihood), max(like.nulls))), 
     main="comparison of observed with null model Patefield")
abline(v=(mod@likelihood), col="red", lwd=2)    
mean(like.nulls)
sd(like.nulls)
mod@likelihood
praw <- sum(like.nulls>(mod@likelihood)) / length(like.nulls)
ifelse(praw > 0.5, 1-praw, praw)                                 
(z <- (mod@likelihood - mean(like.nulls))/sd(like.nulls))         

###### periurban5
library(bipartite)
rm(list= ls())
datos<- read.csv("periurban5.csv", row.names=1)
mod <- computeModules(web=datos, steps=1E12, deep=F)
mod@likelihood
plotModuleWeb(mod)
nulls <- nullmodel(datos, N=100, method="r2d")
modules.nulls <- sapply(nulls, computeModules)
like.nulls <- sapply(modules.nulls, function(x) x@likelihood)
plot(density(like.nulls), xlim=c(min((mod@likelihood), min(like.nulls)), max((mod@likelihood), max(like.nulls))), 
     main="comparison of observed with null model Patefield")
abline(v=(mod@likelihood), col="red", lwd=2)    
mean(like.nulls)
sd(like.nulls)
mod@likelihood
praw <- sum(like.nulls>(mod@likelihood)) / length(like.nulls)
ifelse(praw > 0.5, 1-praw, praw)                                  
(z <- (mod@likelihood - mean(like.nulls))/sd(like.nulls))        

###### periurban6
library(bipartite)
rm(list= ls())
datos<- read.csv("periurban6.csv", row.names=1)
mod <- computeModules(web=datos, steps=1E7, deep=F)
mod@likelihood
plotModuleWeb(mod)
nulls <- nullmodel(datos, N=100, method="r2d")
modules.nulls <- sapply(nulls, computeModules)
like.nulls <- sapply(modules.nulls, function(x) x@likelihood)
plot(density(like.nulls), xlim=c(min((mod@likelihood), min(like.nulls)), max((mod@likelihood), max(like.nulls))), 
     main="comparison of observed with null model Patefield")
abline(v=(mod@likelihood), col="red", lwd=2)    
mean(like.nulls)
sd(like.nulls)
mod@likelihood
praw <- sum(like.nulls>(mod@likelihood)) / length(like.nulls)
ifelse(praw > 0.5, 1-praw, praw)                                  
(z <- (mod@likelihood - mean(like.nulls))/sd(like.nulls)) 

###### periurban7
library(bipartite)
rm(list= ls())
datos<- read.csv("periurban7.csv", row.names=1)
mod <- computeModules(web=datos, steps=1E3, deep=F)
mod@likelihood
plotModuleWeb(mod)
nulls <- nullmodel(datos, N=100, method="r2d")
modules.nulls <- sapply(nulls, computeModules)
like.nulls <- sapply(modules.nulls, function(x) x@likelihood)
plot(density(like.nulls), xlim=c(min((mod@likelihood), min(like.nulls)), max((mod@likelihood), max(like.nulls))), 
     main="comparison of observed with null model Patefield")
abline(v=(mod@likelihood), col="red", lwd=2)    
mean(like.nulls)
sd(like.nulls)
mod@likelihood
praw <- sum(like.nulls>(mod@likelihood)) / length(like.nulls)
ifelse(praw > 0.5, 1-praw, praw)                                  
(z <- (mod@likelihood - mean(like.nulls))/sd(like.nulls))

###### periurban8
library(bipartite)
rm(list= ls())
datos<- read.csv("periurban8.csv", row.names=1)
mod <- computeModules(web=datos, steps=1E3, deep=F)
mod@likelihood
plotModuleWeb(mod)
nulls <- nullmodel(datos, N=100, method="r2d")
modules.nulls <- sapply(nulls, computeModules)
like.nulls <- sapply(modules.nulls, function(x) x@likelihood)
plot(density(like.nulls), xlim=c(min((mod@likelihood), min(like.nulls)), max((mod@likelihood), max(like.nulls))), 
     main="comparison of observed with null model Patefield")
abline(v=(mod@likelihood), col="red", lwd=2)    
mean(like.nulls)
sd(like.nulls)
mod@likelihood
praw <- sum(like.nulls>(mod@likelihood)) / length(like.nulls)
ifelse(praw > 0.5, 1-praw, praw)                                  
(z <- (mod@likelihood - mean(like.nulls))/sd(like.nulls))

###### periurban9
library(bipartite)
rm(list= ls())
datos<- read.csv("periurban9.csv", row.names=1)
mod <- computeModules(web=datos, steps=1E11, deep=F)
mod@likelihood
plotModuleWeb(mod)
nulls <- nullmodel(datos, N=100, method="r2d")
modules.nulls <- sapply(nulls, computeModules)
like.nulls <- sapply(modules.nulls, function(x) x@likelihood)
plot(density(like.nulls), xlim=c(min((mod@likelihood), min(like.nulls)), max((mod@likelihood), max(like.nulls))), 
     main="comparison of observed with null model Patefield")
abline(v=(mod@likelihood), col="red", lwd=2)    
mean(like.nulls)
sd(like.nulls)
mod@likelihood
praw <- sum(like.nulls>(mod@likelihood)) / length(like.nulls)
ifelse(praw > 0.5, 1-praw, praw)                                  
(z <- (mod@likelihood - mean(like.nulls))/sd(like.nulls))

############################## Calculate Modularity in urban Areas #######################################
########urban1
library(bipartite)
rm(list= ls())
datos<- read.csv("urban1.csv", row.names=1)
mod <- computeModules(web=datos, steps=1E3, deep=F)
mod@likelihood
plotModuleWeb(mod)
nulls <- nullmodel(datos, N=100, method="r2d")
modules.nulls <- sapply(nulls, computeModules)
like.nulls <- sapply(modules.nulls, function(x) x@likelihood)
plot(density(like.nulls), xlim=c(min((mod@likelihood), min(like.nulls)), max((mod@likelihood), max(like.nulls))), 
     main="comparison of observed with null model Patefield")
abline(v=(mod@likelihood), col="red", lwd=2)    
mean(like.nulls)
sd(like.nulls)
mod@likelihood
praw <- sum(like.nulls>(mod@likelihood)) / length(like.nulls)
ifelse(praw > 0.5, 1-praw, praw)                                  
(z <- (mod@likelihood - mean(like.nulls))/sd(like.nulls))

########urban2
library(bipartite)
rm(list= ls())
datos<- read.csv("urban2.csv", row.names=1)
mod <- computeModules(web=datos, steps=1E7, deep=F)
mod@likelihood
plotModuleWeb(mod)
nulls <- nullmodel(datos, N=100, method="r2d")
modules.nulls <- sapply(nulls, computeModules)
like.nulls <- sapply(modules.nulls, function(x) x@likelihood)
plot(density(like.nulls), xlim=c(min((mod@likelihood), min(like.nulls)), max((mod@likelihood), max(like.nulls))), 
     main="comparison of observed with null model Patefield")
abline(v=(mod@likelihood), col="red", lwd=2)    
mean(like.nulls)
sd(like.nulls)
mod@likelihood
praw <- sum(like.nulls>(mod@likelihood)) / length(like.nulls)
ifelse(praw > 0.5, 1-praw, praw)                                  
(z <- (mod@likelihood - mean(like.nulls))/sd(like.nulls))

########urban4
library(bipartite)
rm(list= ls())
datos<- read.csv("urban4.csv", row.names=1)
mod <- computeModules(web=datos, steps=1E3, deep=F)
mod@likelihood
plotModuleWeb(mod)
nulls <- nullmodel(datos, N=100, method="r2d")
modules.nulls <- sapply(nulls, computeModules)
like.nulls <- sapply(modules.nulls, function(x) x@likelihood)
plot(density(like.nulls), xlim=c(min((mod@likelihood), min(like.nulls)), max((mod@likelihood), max(like.nulls))), 
     main="comparison of observed with null model Patefield")
abline(v=(mod@likelihood), col="red", lwd=2)    
mean(like.nulls)
sd(like.nulls)
mod@likelihood
praw <- sum(like.nulls>(mod@likelihood)) / length(like.nulls)
ifelse(praw > 0.5, 1-praw, praw)                                  
(z <- (mod@likelihood - mean(like.nulls))/sd(like.nulls))

########urban5
library(bipartite)
rm(list= ls())
datos<- read.csv("urban5.csv", row.names=1)
mod <- computeModules(web=datos, steps=1E7, deep=F)
mod@likelihood
plotModuleWeb(mod)
nulls <- nullmodel(datos, N=100, method="r2d")
modules.nulls <- sapply(nulls, computeModules)
like.nulls <- sapply(modules.nulls, function(x) x@likelihood)
plot(density(like.nulls), xlim=c(min((mod@likelihood), min(like.nulls)), max((mod@likelihood), max(like.nulls))), 
     main="comparison of observed with null model Patefield")
abline(v=(mod@likelihood), col="red", lwd=2)    
mean(like.nulls)
sd(like.nulls)
mod@likelihood
praw <- sum(like.nulls>(mod@likelihood)) / length(like.nulls)
ifelse(praw > 0.5, 1-praw, praw)                                  
(z <- (mod@likelihood - mean(like.nulls))/sd(like.nulls))

########urban6
library(bipartite)
rm(list= ls())
datos<- read.csv("urban6.csv", row.names=1)
mod <- computeModules(web=datos, steps=1E7, deep=F)
mod@likelihood
plotModuleWeb(mod)
nulls <- nullmodel(datos, N=100, method="r2d")
modules.nulls <- sapply(nulls, computeModules)
like.nulls <- sapply(modules.nulls, function(x) x@likelihood)
plot(density(like.nulls), xlim=c(min((mod@likelihood), min(like.nulls)), max((mod@likelihood), max(like.nulls))), 
     main="comparison of observed with null model Patefield")
abline(v=(mod@likelihood), col="red", lwd=2)    
mean(like.nulls)
sd(like.nulls)
mod@likelihood
praw <- sum(like.nulls>(mod@likelihood)) / length(like.nulls)
ifelse(praw > 0.5, 1-praw, praw)                                  
(z <- (mod@likelihood - mean(like.nulls))/sd(like.nulls))

########urban7
library(bipartite)
rm(list= ls())
datos<- read.csv("urban7.csv", row.names=1)
mod <- computeModules(web=datos, steps=1E7, deep=F)
mod@likelihood
plotModuleWeb(mod)
nulls <- nullmodel(datos, N=100, method="r2d")
modules.nulls <- sapply(nulls, computeModules)
like.nulls <- sapply(modules.nulls, function(x) x@likelihood)
plot(density(like.nulls), xlim=c(min((mod@likelihood), min(like.nulls)), max((mod@likelihood), max(like.nulls))), 
     main="comparison of observed with null model Patefield")
abline(v=(mod@likelihood), col="red", lwd=2)    
mean(like.nulls)
sd(like.nulls)
mod@likelihood
praw <- sum(like.nulls>(mod@likelihood)) / length(like.nulls)
ifelse(praw > 0.5, 1-praw, praw)                                  
(z <- (mod@likelihood - mean(like.nulls))/sd(like.nulls))

########urban9
library(bipartite)
rm(list= ls())
datos<- read.csv("urban9.csv", row.names=1)
mod <- computeModules(web=datos, steps=1E1, deep=F)
mod@likelihood
plotModuleWeb(mod)
nulls <- nullmodel(datos, N=100, method="r2d")
modules.nulls <- sapply(nulls, computeModules)
like.nulls <- sapply(modules.nulls, function(x) x@likelihood)
plot(density(like.nulls), xlim=c(min((mod@likelihood), min(like.nulls)), max((mod@likelihood), max(like.nulls))), 
     main="comparison of observed with null model Patefield")
abline(v=(mod@likelihood), col="red", lwd=2)    
mean(like.nulls)
sd(like.nulls)
mod@likelihood
praw <- sum(like.nulls>(mod@likelihood)) / length(like.nulls)
ifelse(praw > 0.5, 1-praw, praw)                                  
(z <- (mod@likelihood - mean(like.nulls))/sd(like.nulls))

##############################################################################################################
####### Testing Nestedness of Avian Dawn Choruses in Highly Urbanized and Periurban Areas ####################
##############################################################################################################

############################## Calculate Nestedness in Urbanized Areas ################################
#######urban1
rm(list= ls())
centro<- read.csv("urban1.csv", row.names=1)
obs <- unlist(networklevel(centro, index="weighted NODF"))
nulls <- nullmodel(centro, N=1000, method="r2d") #demora
null <- unlist(sapply(nulls, networklevel, index="weighted NODF")) 
plot(density(null), xlim=c(min(obs, min(null)), max(obs, max(null))), 
     main="CWNODF null model urban", xlab = "WNODF")
abline(v=obs, col="red", lwd=2)    
mean(null)
sd(null)
obs
praw <- sum(null>obs) / length(null)
ifelse(praw > 0.5, 1-praw, praw)      
(z <- (obs - mean(null))/sd(null))     

#######urban2
rm(list= ls())
centro<- read.csv("urban2.csv", row.names=1)
obs <- unlist(networklevel(centro, index="weighted NODF"))
nulls <- nullmodel(centro, N=1000, method="r2d") #demora
null <- unlist(sapply(nulls, networklevel, index="weighted NODF")) 
plot(density(null), xlim=c(min(obs, min(null)), max(obs, max(null))), 
     main="CWNODF null model urban", xlab = "WNODF")
abline(v=obs, col="red", lwd=2)    
mean(null)
sd(null)
obs
praw <- sum(null>obs) / length(null)
ifelse(praw > 0.5, 1-praw, praw)      
(z <- (obs - mean(null))/sd(null))  

#######urban4
rm(list= ls())
centro<- read.csv("urban4.csv", row.names=1)
obs <- unlist(networklevel(centro, index="weighted NODF"))
nulls <- nullmodel(centro, N=1000, method="r2d") #demora
null <- unlist(sapply(nulls, networklevel, index="weighted NODF")) 
plot(density(null), xlim=c(min(obs, min(null)), max(obs, max(null))), 
     main="CWNODF null model urban", xlab = "WNODF")
abline(v=obs, col="red", lwd=2)    
mean(null)
sd(null)
obs
praw <- sum(null>obs) / length(null)
ifelse(praw > 0.5, 1-praw, praw)      
(z <- (obs - mean(null))/sd(null)) 

#######urban5
rm(list= ls())
centro<- read.csv("urban5.csv", row.names=1)
obs <- unlist(networklevel(centro, index="weighted NODF"))
nulls <- nullmodel(centro, N=1000, method="r2d") #demora
null <- unlist(sapply(nulls, networklevel, index="weighted NODF")) 
plot(density(null), xlim=c(min(obs, min(null)), max(obs, max(null))), 
     main="CWNODF null model urban", xlab = "WNODF")
abline(v=obs, col="red", lwd=2)    
mean(null)
sd(null)
obs
praw <- sum(null>obs) / length(null)
ifelse(praw > 0.5, 1-praw, praw)      
(z <- (obs - mean(null))/sd(null))

#######urban6
rm(list= ls())
centro<- read.csv("urban6.csv", row.names=1)
obs <- unlist(networklevel(centro, index="weighted NODF"))
nulls <- nullmodel(centro, N=1000, method="r2d") #demora
null <- unlist(sapply(nulls, networklevel, index="weighted NODF")) 
plot(density(null), xlim=c(min(obs, min(null)), max(obs, max(null))), 
     main="CWNODF null model urban", xlab = "WNODF")
abline(v=obs, col="red", lwd=2)    
mean(null)
sd(null)
obs
praw <- sum(null>obs) / length(null)
ifelse(praw > 0.5, 1-praw, praw)      
(z <- (obs - mean(null))/sd(null))

#######urban7
rm(list= ls())
centro<- read.csv("urban7.csv", row.names=1)
obs <- unlist(networklevel(centro, index="weighted NODF"))
nulls <- nullmodel(centro, N=1000, method="r2d") #demora
null <- unlist(sapply(nulls, networklevel, index="weighted NODF")) 
plot(density(null), xlim=c(min(obs, min(null)), max(obs, max(null))), 
     main="CWNODF null model urban", xlab = "WNODF")
abline(v=obs, col="red", lwd=2)    
mean(null)
sd(null)
obs
praw <- sum(null>obs) / length(null)
ifelse(praw > 0.5, 1-praw, praw)      
(z <- (obs - mean(null))/sd(null))

#######urban9
rm(list= ls())
centro<- read.csv("urban9.csv", row.names=1)
obs <- unlist(networklevel(centro, index="weighted NODF"))
nulls <- nullmodel(centro, N=1000, method="r2d") #demora
null <- unlist(sapply(nulls, networklevel, index="weighted NODF")) 
plot(density(null), xlim=c(min(obs, min(null)), max(obs, max(null))), 
     main="CWNODF null model urban", xlab = "WNODF")
abline(v=obs, col="red", lwd=2)    
mean(null)
sd(null)
obs
praw <- sum(null>obs) / length(null)
ifelse(praw > 0.5, 1-praw, praw)      
(z <- (obs - mean(null))/sd(null))

#######periurban1
rm(list= ls())
centro<- read.csv("periurban1.csv", row.names=1)
obs <- unlist(networklevel(centro, index="weighted NODF"))
nulls <- nullmodel(centro, N=1000, method="r2d") #demora
null <- unlist(sapply(nulls, networklevel, index="weighted NODF")) 
plot(density(null), xlim=c(min(obs, min(null)), max(obs, max(null))), 
     main="CWNODF null model urban", xlab = "WNODF")
abline(v=obs, col="red", lwd=2)    
mean(null)
sd(null)
obs
praw <- sum(null>obs) / length(null)
ifelse(praw > 0.5, 1-praw, praw)      
(z <- (obs - mean(null))/sd(null))

#######periurban2
rm(list= ls())
centro<- read.csv("periurban2.csv", row.names=1)
obs <- unlist(networklevel(centro, index="weighted NODF"))
nulls <- nullmodel(centro, N=1000, method="r2d") #demora
null <- unlist(sapply(nulls, networklevel, index="weighted NODF")) 
plot(density(null), xlim=c(min(obs, min(null)), max(obs, max(null))), 
     main="CWNODF null model urban", xlab = "WNODF")
abline(v=obs, col="red", lwd=2)    
mean(null)
sd(null)
obs
praw <- sum(null>obs) / length(null)
ifelse(praw > 0.5, 1-praw, praw)      
(z <- (obs - mean(null))/sd(null))

#######periurban3
rm(list= ls())
centro<- read.csv("periurban3.csv", row.names=1)
obs <- unlist(networklevel(centro, index="weighted NODF"))
nulls <- nullmodel(centro, N=1000, method="r2d") #demora
null <- unlist(sapply(nulls, networklevel, index="weighted NODF")) 
plot(density(null), xlim=c(min(obs, min(null)), max(obs, max(null))), 
     main="CWNODF null model urban", xlab = "WNODF")
abline(v=obs, col="red", lwd=2)    
mean(null)
sd(null)
obs
praw <- sum(null>obs) / length(null)
ifelse(praw > 0.5, 1-praw, praw)      
(z <- (obs - mean(null))/sd(null))

#######periurban4
rm(list= ls())
centro<- read.csv("periurban4.csv", row.names=1)
obs <- unlist(networklevel(centro, index="weighted NODF"))
nulls <- nullmodel(centro, N=1000, method="r2d") #demora
null <- unlist(sapply(nulls, networklevel, index="weighted NODF")) 
plot(density(null), xlim=c(min(obs, min(null)), max(obs, max(null))), 
     main="CWNODF null model urban", xlab = "WNODF")
abline(v=obs, col="red", lwd=2)    
mean(null)
sd(null)
obs
praw <- sum(null>obs) / length(null)
ifelse(praw > 0.5, 1-praw, praw)      
(z <- (obs - mean(null))/sd(null))

#######periurban5
rm(list= ls())
centro<- read.csv("periurban5.csv", row.names=1)
obs <- unlist(networklevel(centro, index="weighted NODF"))
nulls <- nullmodel(centro, N=1000, method="r2d") #demora
null <- unlist(sapply(nulls, networklevel, index="weighted NODF")) 
plot(density(null), xlim=c(min(obs, min(null)), max(obs, max(null))), 
     main="CWNODF null model urban", xlab = "WNODF")
abline(v=obs, col="red", lwd=2)    
mean(null)
sd(null)
obs
praw <- sum(null>obs) / length(null)
ifelse(praw > 0.5, 1-praw, praw)      
(z <- (obs - mean(null))/sd(null))

#######periurban6
rm(list= ls())
centro<- read.csv("periurban6.csv", row.names=1)
obs <- unlist(networklevel(centro, index="weighted NODF"))
nulls <- nullmodel(centro, N=1000, method="r2d") #demora
null <- unlist(sapply(nulls, networklevel, index="weighted NODF")) 
plot(density(null), xlim=c(min(obs, min(null)), max(obs, max(null))), 
     main="CWNODF null model urban", xlab = "WNODF")
abline(v=obs, col="red", lwd=2)    
mean(null)
sd(null)
obs
praw <- sum(null>obs) / length(null)
ifelse(praw > 0.5, 1-praw, praw)      
(z <- (obs - mean(null))/sd(null))

#######periurban7
rm(list= ls())
centro<- read.csv("periurban7.csv", row.names=1)
obs <- unlist(networklevel(centro, index="weighted NODF"))
nulls <- nullmodel(centro, N=1000, method="r2d") #demora
null <- unlist(sapply(nulls, networklevel, index="weighted NODF")) 
plot(density(null), xlim=c(min(obs, min(null)), max(obs, max(null))), 
     main="CWNODF null model urban", xlab = "WNODF")
abline(v=obs, col="red", lwd=2)    
mean(null)
sd(null)
obs
praw <- sum(null>obs) / length(null)
ifelse(praw > 0.5, 1-praw, praw)      
(z <- (obs - mean(null))/sd(null))

#######periurban8
rm(list= ls())
centro<- read.csv("periurban8.csv", row.names=1)
obs <- unlist(networklevel(centro, index="weighted NODF"))
nulls <- nullmodel(centro, N=1000, method="r2d") #demora
null <- unlist(sapply(nulls, networklevel, index="weighted NODF")) 
plot(density(null), xlim=c(min(obs, min(null)), max(obs, max(null))), 
     main="CWNODF null model urban", xlab = "WNODF")
abline(v=obs, col="red", lwd=2)    
mean(null)
sd(null)
obs
praw <- sum(null>obs) / length(null)
ifelse(praw > 0.5, 1-praw, praw)      
(z <- (obs - mean(null))/sd(null))

#######periurban9
rm(list= ls())
centro<- read.csv("periurban9.csv", row.names=1)
obs <- unlist(networklevel(centro, index="weighted NODF"))
nulls <- nullmodel(centro, N=1000, method="r2d") #demora
null <- unlist(sapply(nulls, networklevel, index="weighted NODF")) 
plot(density(null), xlim=c(min(obs, min(null)), max(obs, max(null))), 
     main="CWNODF null model urban", xlab = "WNODF")
abline(v=obs, col="red", lwd=2)    
mean(null)
sd(null)
obs
praw <- sum(null>obs) / length(null)
ifelse(praw > 0.5, 1-praw, praw)      
(z <- (obs - mean(null))/sd(null))

##############################################################################################################
#######              Comparing WNODF and QNODF between periurban and urban areas          ####################
##############################################################################################################
rm(list= ls())
datos<- read.csv("netsumm.csv", header = TRUE, sep = ",")
attach(datos)
names(datos)

par(mfrow=c(1,3))

boxplot(Q~condition, axes=T, ylab = "modularity (Q)", col=c("gray", "0"), cex.axis=1.7, cex.lab= 1.7,  outpch=16, outcex = 1, boxlty=1, whisklty = 1, staplelwd=2, boxwex=.6)

boxplot(modules~condition, axes=T, ylab = "modules", col=c("gray", "0"), cex.axis=1.7, cex.lab= 1.7,  outpch=16, outcex = 1, boxlty=1, whisklty = 1, staplelwd=2, boxwex=.6)
t.test(modules~condition)
hist(modules)

boxplot(ordered_modules~condition, axes=T, ylab = "time ordered modules", col=c("gray", "0"), cex.axis=1.7, cex.lab= 1.7,  outpch=16, outcex = 1, boxlty=1, whisklty = 1, staplelwd=2, boxwex=.6)
t.test(ordered_modules~condition)
hist(ordered_modules)
        
boxplot(richness~condition, axes=T, ylab = "species richness", col=c("0", "gray"), cex.axis=1.6, cex.lab= 1.8,  outpch=16, outcex = 1, boxlty=1, whisklty = 1, staplelwd=2, boxwex=.6)
t.test(richness~condition)

#######  comparing modularity among sites per urban condition
datos<- read.csv("Q.csv", header = TRUE, sep = ",")
attach(datos)
names(datos)
boxplot(species~condition, axes=T, ylab = "species", col=c("0", "gray"), cex.axis=1.6, cex.lab= 1.8,  outpch=16, outcex = 1, boxlty=1, whisklty = 1, staplelwd=2, boxwex=.6)
#######t.test(species~condition)
#######boxplot(duration~condition, axes=T, ylab = "duration", col=c("0", "gray"), cex.axis=1.6, cex.lab= 1.8,  outpch=16, outcex = 1, boxlty=1, whisklty = 1, staplelwd=2, boxwex=.6)
#######t.test(duration~condition)

##############################################################################################################
######### Calculate Niche overlap metrics for each module in in Highly Urbanized and Periurban Areas #########
##############################################################################################################

# Open the xls file: niche_overlap_modules, and export and save each sheet in cvs format in order to calculate niche overlap (peak frequencies) of the species from the same modules

###################################Niche overlap in Periurban Areas ##########################################
library(EcoSimR)
u1<- read.csv("urban1.csv", row.names=1)
u1 <- niche_null_model(u1, algo = "ra3", metric = "czekanowski", nReps = 1000, saveSeed = FALSE, algoOpts = list(), metricOpts = list(), suppressProg = FALSE)
summary(u1)
plot(u1, type="hist")

modII<- read.csv("perII.csv", row.names=1)
modII <- niche_null_model(modII, algo = "ra3", metric = "czekanowski", nReps = 1000, saveSeed = FALSE, algoOpts = list(), metricOpts = list(), suppressProg = FALSE)
summary(modII)
plot(modII, type="hist")

modIII<- read.csv("perIII.csv", row.names=1)
modIII <- niche_null_model(modIII, algo = "ra3", metric = "czekanowski", nReps = 1000, saveSeed = FALSE, algoOpts = list(), metricOpts = list(), suppressProg = FALSE)
summary(modIII)
plot(modIII, type="hist")

modIV<- read.csv("perIV.csv", row.names=1)
modIV <- niche_null_model(modIV, algo = "ra3", metric = "czekanowski", nReps = 1000, saveSeed = FALSE, algoOpts = list(), metricOpts = list(), suppressProg = FALSE)
summary(modIV)
plot(modIV, type="hist")

#######################################Niche overlap in Urban Areas ##########################################
modI<- read.csv("urbI.csv", row.names=1)
modI <- niche_null_model(modI, algo = "ra3", metric = "czekanowski", nReps = 1000, saveSeed = FALSE, algoOpts = list(), metricOpts = list(), suppressProg = FALSE)
summary(modI)
plot(modI, type="hist")

modII<- read.csv("urbII.csv", row.names=1)
modII <- niche_null_model(modII, algo = "ra3", metric = "czekanowski", nReps = 1000, saveSeed = FALSE, algoOpts = list(), metricOpts = list(), suppressProg = FALSE)
summary(modII)
plot(modII, type="hist")

##############################################################################################################
######### Calculate Phylogenetic distances within modules in Highly Urbanized and Periurban Areas ############
#########        Modified from http://kembellab.ca/r-workshop/biodivR/SK_Biodiversity_R.html      ############
##############################################################################################################
library("picante")
library("vegan")
# community data
comm <- read.csv("modu.csv", header = TRUE, row.names = 1)
# phylogeny data
phy <- read.nexus("consensus_tree_Xalapa")
# convert phylogenety to a distance matrix
phy.dist <- cophenetic(phy)
# calculate ses.mpd
comm.sesmpd <- ses.mpd(comm, phy.dist, null.model = "taxa.labels", abundance.weighted = FALSE,
runs = 999)
head(comm.sesmpd)
# calculate ses.mntd
comm.sesmntd <- ses.mntd(comm, phy.dist, null.model = "taxa.labels", abundance.weighted = FALSE,
runs = 999)
head(comm.sesmntd)
